import isPlainObject from 'isobject';
var FRIENDLY_PSEUDO_REGEX = /^on([A-Z])/;
var UPPERCASE_REGEX = /([A-Z])/g;
var ON_REGEX = /^on-(.*)/g;
var pseudoElements = ['after', 'before', 'first-letter', 'first-line', 'selection', 'backdrop', 'placeholder', 'marker', 'spelling-error', 'grammar-error'];

function friendlyPseudoClassPlugin(style) {
  for (var property in style) {
    var value = style[property];

    if (isPlainObject(value)) {
      var resolvedValue = friendlyPseudoClassPlugin(value);

      if (property.match(FRIENDLY_PSEUDO_REGEX) !== null) {
        var pseudo = property.replace(UPPERCASE_REGEX, function (match) {
          return '-' + match.toLowerCase();
        }).replace(ON_REGEX, function (match, p1) {
          return "".concat(pseudoElements.includes(p1) ? '::' : ':').concat(p1);
        });
        style[pseudo] = resolvedValue;
        delete style[property];
      } else {
        style[property] = resolvedValue;
      }
    }
  }

  return style;
}

export default function friendlyPseudoClass() {
  return friendlyPseudoClassPlugin;
}